// by Alexander Ilyin
// *original belongs at the Dragging Watcher project

#pragma once

#include <windows.h>

#include "map_file.h"
#include "settings.h"
// 'UNICODE_STRING'
//#include <ntsecapi.h>
#include "section.h"


// alignment inside a class is 2
class CWatchImage
{
public:
// must be aligned by 4
	ushort file_path[UPATH_MAX];
	bool have_file_path;
//	UNICODE_STRING file_path;
	char file_name[256];
	bool main_exe;
	DWORD time_stamp;
	uint image_base;
	uint image_size;
	uint image_end;
//	LPVOID section_base;
// *currently - only one section is watched
//	SIZE_T section_size;
// *must not be in settings
// *probably must be defined from PE
//	uint code_offset;
// size in bytes
	uint registration_array_size;
	uint* registration_array;
//	CMapFile* c_map_file;
	bool map_file_loaded;
	__int64 hits_counter;
	bool displaying_dump_boolean_mask;

// may be private, necessary only for Sorting_xxx ()
	section_t sections[SECTIONS_MAX];
	uint sections_num;
	CMapFile c_map_file;

	CWatchImage ();
	~CWatchImage ();
	void ZeroMem (void);
	bool Init (bool is_main_exe, HANDLE file_handle, void* image_base_address);
	void Quit ();
	bool ReadMapFile (void);
#if 0
// just check region, if 'offset == NULL'
	inline bool GetOffset (DWORD address, DWORD* offset)
	{
// *'base_offset == section_base', but I will remake it later
		DWORD base_offset = (DWORD)base_of_image + (DWORD)code_offset;
		if (address < base_offset || address >= base_offset + section_size)
			return 0;
		if (offset)
			*offset = address - base_offset;
		return 1;
	}
#endif
	bool IsAddressInImage (uint address);
	bool Hit (uint address);
//	void ShowFunction (uint address);
	void Exception (uint address);
	bool GetFunctionInfo (map_file_function_info_t** map_file_function_info, uint offset);
protected:
private:

	bool FindSection (int* section_index, uint offset);

//	friend void Sorting_ByFunctions_Section (...);
//	friend void Sorting_ByFunctions_Section (CWatchImage*, int, section_t*);
};

void Image_ShowTotalMemoryAllocated ();

