// by Alexander Ilyin

#include "section.h"


void Section_Init (section_t* section, PIMAGE_SECTION_HEADER image_section_header)
{
	section->offset_begin = image_section_header->VirtualAddress;
	section->size = image_section_header->Misc.VirtualSize;
	section->offset_end = section->offset_begin + section->size;
	section->is_executable = !! (image_section_header->Characteristics & IMAGE_SCN_MEM_EXECUTE);
}

