#pragma once

// by Alexander Ilyin
// errors handling


void Error (char* fmt,...);
void Error_NoExit (char* format, ...);

void _Assert (int expr, char* expr_text, char* filename, int linenum);

// ways to bring expression to boolean :  MSVC 6.0 SP 6 compiler compiles '!! expression' short and properly;
// 'expression || 0' compiles into much bigger code
#define Assert(_expression_) _Assert(!! (_expression_), #_expression_, __FILE__, __LINE__)


